import os
import sipconfig
from PyQt4 import pyqtconfig

# The name of the SIP build file generated by SIP and used by the build
# system.
build_file = "Bdoc.sbf"

# Get the PyQt configuration information.
config = pyqtconfig.Configuration()

# Get the extra SIP flags needed by the imported qt module.  Note that
# this normally only includes those flags (-x and -t) that relate to SIP's
# versioning system.
qt_sip_flags = config.pyqt_sip_flags

# Run SIP to generate the code.  Note that we tell SIP where to find the qt
# module's specification files using the -I flag.
os.system(" ".join([config.sip_bin, "-c", ".", "-b", build_file, "-I",
config.pyqt_sip_dir, qt_sip_flags, "Bdoc.sip"]))

# We are going to install the SIP specification file for this module and
# its configuration module.
installs = []

installs.append(["Bdoc.sip", os.path.join(config.default_sip_dir,
"BDocDocument")])

# Create the Makefile.  The QtModuleMakefile class provided by the
# pyqtconfig module takes care of all the extra preprocessor, compiler and
# linker flags needed by the Qt library.
makefile = pyqtconfig.QtCoreModuleMakefile(
     configuration=config,
         build_file=build_file,
         installs=installs
     )

# Add the library we are wrapping.  The name doesn't include any platform
# specific prefixes or extensions (e.g. the "lib" prefix on UNIX, or the
# ".dll" extension on Windows).
makefile.INCDIR.append("/usr/local/include/libdigidoc")

makefile.INCDIR_QT.append("/usr/include/qt4/QtCore")
makefile.INCDIR_QT.append("/usr/include/qt4/QtXml")
makefile.INCDIR_QT.append("/usr/include/qt4/QtNetwork")
makefile.INCDIR_QT.append("/usr/local/include/digidocpp")
makefile.INCDIR_QT.append("RUTA_A_SUSTITUIR/libdigidocpp/libdigidocpp/src/")
#makefile.INCDIR_QT.append("/usr/include/qt4/QtCore")#QPair y QStack
#makefile.INCDIR_QT.append("/usr/include/qt4/Qt")#QPair y QStack
makefile.LFLAGS.append("-L/user/local/lib")
makefile.LFLAGS.append("-L/RUTA_A_SUSTITUIR/trunk") # Ruta de libfirmaxml
makefile.extra_libs = ["firmaxml","digidoc","digidocpp","QtCore","QtNetwork","QtXml"]

# Generate the Makefile itself.
makefile.generate()
