# -*- encoding: utf-8 -*-
import base64
import datetime
import Bdoc
from PyQt4.QtCore import *

from osv import fields, osv


class firma_bandeja(osv.osv):
    
    _name = 'firma.bandeja'
    _rec_name = 'nombre'
    
    _columns = {
        'nombre': fields.char('Nombre',size=100,required=True,readonly=False),
        'descripcion': fields.char('Descripción',size=255,required=True,readonly=False),
        'id_bandejas':fields.one2many('firma.bandeja_usuario', 'id_bandeja', 'Bandeja', required=True),
    }
    
firma_bandeja()

class firma_firmantes(osv.osv_memory):
    
    _name = 'firma.firmantes'
    _rec_name = 'firmante'    
    _columns = {
    
        'firmante': fields.char('Firmante',size=50,required=False,readonly=False),
        'fecha' : fields.char('Fecha',size=15,required=False,readonly=False),
        'valida' : fields.boolean('Valida'),
        'firmantes_id':fields.many2one('firma.documento','Documento', required=False, ondelete='cascade'), 
    }
    
    def verificar_archivo(self,cr,uid,ids,context=None):
        return False
    
    def verificar_archivo2(self,cr,uid,ids,context=None):
        return False

firma_firmantes()

class firma_documento(osv.osv):
    
    _name = 'firma.documento'
    _rec_name = 'nombre'    
    _columns = {
    
        'nombre': fields.char('Nombre',size=50,required=True,readonly=False),
        'nombre_file': fields.char('Nombre',size=50,required=True,readonly=False),
        'fecha' : fields.date('Fecha',required=True,readonly=False),
        'documento':fields.binary('Archivo Firmar', required=True, readonly=False, filters='*.pdf,*.bdoc'),
        'id_bandeja_actual': fields.many2one('firma.bandeja','Bandeja', required=True), # ondelete='cascade'
        'id_bandeja_abandonada': fields.many2one('firma.bandeja','Bandeja Abandonada', required=False), # ondelete='cascade'
    }
    
    
    def create(self,cr,uid,ids,context=None):
        """
        Sobreescritura del metodo create de openerp
        """
        # OBTENEMOS EL NOMBRE DEL ARCHIVO BDOC
        ids['nombre'] = "%s.bdoc" % ids['nombre_file']
        # AQUI CREAMOS EL CONTENEDOR BDOC CON EL ARCHIVO A FIRMAR QUE EL USUARIO ESTÁ INGRESANDO. POR AHORA NO TENEMOS EL METODO
        bdoc = Bdoc.BDocDocument()
        bdoc.init()
        # AQUI HAY QUE GENERAR UN NOMBRE ALEATORIO, ESTO SE DEBE CORREGIR
        ruta_bdoc = "/tmp/%s" % ids['nombre']
        bdoc.create(ruta_bdoc)
        # CREAMO EL ARCHIVO QUE SE DESEA FIRMAR
        ruta_fuente = '/tmp/%s' % ids['nombre_file']
        documento_fuente = open(ruta_fuente,"w")
        # AQUI PUEDE SER QUE HAYA UN PROBLEMA CON LO DEL DECODE
        documento_fuente.write(base64.decodestring(ids['documento']))
        documento_fuente.close()
        bdoc.addDocument(ruta_fuente);
        bdoc.saveBDocContainer(ruta_bdoc)
        ids['documento'] = base64.encodestring(open(ruta_bdoc,'r').read())
        
        # BORRAMOS LOS ARCHIVOS
        
        ####return super(osv.osv, self).create(cr,uid,ids,context=context)
        data_documento = super(osv.osv, self).create(cr,uid,ids,context=context)
        
        # PROCEDEMOS A ALMACENAR LOS USUARIOS A LOS QUE ESTE DOCUMENTO ESTÁ ASOCIADO
        obj_bandeja_usuario = self.pool.get('firma.bandeja_usuario')
        obj_documento_usuario = self.pool.get('firma.documento_usuario')
        ids_usuario = obj_bandeja_usuario.search(cr, uid,[('id_bandeja','=',ids['id_bandeja_actual'])])
        for id_usuario in ids_usuario:
            data = {'id_documento':data_documento,
                    'id_usuario':id_usuario,
                    'estado':'e'
            }
            
            obj_documento_usuario.create(cr,uid,data,context=context)
        
        
        return data_documento
        
        
        
    
    def cargar_archivo_firmar(self,cr,uid,ids,context=None):
        """
        ESTE METODO ES LLAMADO DESDE LA VISTA. COMO ANTES DE EJECUTAR ESTE MÉTODO SE EJECUTA EL CREATE Y
        EL CREATE LO SOBRESCRIBIMOS PARA CREAR LOS VALORES DINÁMICOS 
        """
        
        return False
    
    def preparar_firma(self,cr,uid,ids,context=None):
        
        # ESTE MÉTODO DEBE LLAMAR AL MODELO DE firma.info PARA QUE ESTE MUESTRE EL FORMULARIO A LLENAR Y HAGA SOLICITUD DEL CERTIFICADO
        obj_info = self.pool.get('firma.info')
        return obj_info.desplegar_form(cr,uid,ids,context)
    
    def listar_firmantes(self,cr,uid,ids,context=None):
        
        data = self.read(cr,uid,ids)[0]
        ruta_fuente = '/tmp/%s' % data['nombre_file']
        documento_fuente = open(ruta_fuente,"w")
        documento_fuente.write(base64.decodestring(data['documento']))
        documento_fuente.close()
        BDoc = Bdoc.BDocDocument()
        BDoc.init()
        BDoc.openBDocContainer(ruta_fuente)
        
        ns = BDoc.signatureCount()
        obj_firmantes = self.pool.get('firma.firmantes')
        elementos = obj_firmantes.search(cr, uid,[])
        obj_firmantes.unlink(cr, uid, elementos, context=context)
        for x in range(ns):
            valida = False
            if BDoc.validateSignature(x) == 0:
                valida = True
            res = {'firmante':'%s' % BDoc.subjectCertificateCommonName(x),'fecha':'%s' % BDoc.signatureDateTime(x) ,'valida':valida,'firmantes_id':1}
            obj_firmantes.create(cr,uid,res,context=context)
        
        
        return { 
            'view_type': 'form',
            'view_mode':'tree',
            'res_model': 'firma.firmantes',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'res_id': '',
            'ref': 'firma_tree_firmantes'
        }
        
        

firma_documento()

class firma_firmar(osv.osv_memory):
    
    _name = 'firma.firmar'
    _rec_name = 'nombre'
    _columns = {
        'archivo_bdoc': fields.binary('Archivo Firmar', required=True, readonly=False, filters='*.pdf,*.bdoc'),
        'nombre_bdoc': fields.char('Nombre',size=40),
        'nombre_adjunto': fields.char('Nombre',size=40, readonly=True),
        'archivo_adjunto': fields.binary('Adjunto', required=False, readonly=True, filters='*.bdoc'),
        'tipo': fields.char('Tipo',size=15,required=False,readonly=True),
        #'talla': fields.char('Talla',size=15,required=False,readonly=True),
        'hash': fields.char('hash',size=50,required=False,readonly=False),
        'id_certificado': fields.char('ID Certificado',size=40,required=True),
        'firma': fields.char('firma',size=250,required=False,readonly=False),
        'firmantes_ids':fields.one2many('firma.firmantes','firmantes_id','Firmantes')
    }
    
    _BDoc = {}
    ruta_certificado = None
    idDocumento = None
    ruta_bdoc = None
    
    def cargar_archivo(self,cr,uid,ids,context=None,obj_info=None):
        
        # FORMA COMO RECUPERAMOS LOS DATOS DEL FORMULARIO
        data = self.read(cr, uid, ids)[0]
        # COLOCAMOS AL BDOC EN UNA RUTA TEMPORAL PARA PODER PROCESARLO CON LA LIBRERÍA LIBDIGIDOC. ESTE NOMBRE DEBE SER ALEATORIO
        
        self.ruta_bdoc = "/tmp/%s" % data['nombre_bdoc']
        f = open(self.ruta_bdoc,"w")
        f.write(base64.decodestring(data['archivo_bdoc']))
        f.close()
        # INICIAMOS EL OBJETO BDOC
        self._BDoc[uid] = Bdoc.BDocDocument()
        self._BDoc[uid].init()
        self._BDoc[uid].openBDocContainer(self.ruta_bdoc)
        
        # AQUI OBTENEMOS EL DOCUMENTO FUENTE. ESTO LO ENTREGA LIBDIGIDOC.
        ruta_adjunto = "/tmp"
        self._BDoc[uid].saveDocument(0,ruta_adjunto)
        archivo_adjunto = base64.encodestring(open("%s/%s" % (ruta_adjunto,data['nombre_adjunto']),'r').read())
        # DEBE OBTENERSE EL CERTIFICADO. DE MOMENTO NO VAMOS A TOMAR ESTO ENCUENTA, PERO PARA CUANDO ESTÉ LISTO EL API DE BDOC ES NECEARIO QUE
        # EL CERTIFICADO ESTÉ EN ESTE PUNTO
        
        digest = QString() 
        
        self.ruta_certificado = "/tmp/certificado.crt"
        file_cert = open(self.ruta_certificado,"w")
        file_cert.write(obj_info['certificado'])
        file_cert.close()
        hash_libdigidoc = self._BDoc[uid].presignWeb(obj_info['perfil'], obj_info['ciudad'], obj_info['estado'], obj_info['codigo_postal'], obj_info['pais'],obj_info['rol'], self.ruta_certificado, digest);
        
        # OBTENEMOS EL HASH DEL ARCHIVO A FIRMAR, ESTO ME LO DEVUELVE LA LIBRERÍA LIBDIGIDOC Y ES EL HASH DEL DOCUMENTO QUE SE DESEA FIRMAR
        hash_libdigidoc = digest
        
        ##'archivo_bdoc':data['archivo_bdoc']
        res = {'hash': hash_libdigidoc,'archivo_adjunto':archivo_adjunto}
        self.write(cr,uid,ids,res)
        # LLAMAMOS AL MÉTODO QUE CARGA LA LISTA DE PERSONAS QUE HAN FIRMADO EL DOCUMENTO
        self.listar_firmantes(cr,uid,ids,context,data)
        
        return { 
            'view_type': 'form',
            'view_mode':'form',
            'res_model': 'firma.firmar',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'res_id': ids[0],
            'ref': 'firma_electronica'
        }
        
        
    def listar_firmantes(self,cr,uid,ids,context,data):
        
        obj_firmantes = self.pool.get('firma.firmantes')
        elementos = obj_firmantes.search(cr, uid,[])
        obj_firmantes.unlink(cr, uid, elementos, context=context)
        
        result = self._BDoc[uid].validateOffline()
        ns = self._BDoc[uid].signatureCount()
        
        for x in range(ns):
            valida = False
            if self._BDoc[uid].validateSignature(x) == 0:
                valida = True
                
            res = {'firmante':'%s' % self._BDoc[uid].subjectCertificateCommonName(x),'fecha':'%s' % self._BDoc[uid].signatureDateTime(x) ,'valida':valida,'firmantes_id':data['id']}
            obj_firmantes.create(cr,uid,res,context=context)
    
    def firmar_archivo(self,cr,uid,ids,context=None):
        
        data = self.read(cr, uid, ids)[0]
        
        if not data['firma']:
            return False
        
        # PROCEDEMOS A AÑADIR LA FIRMA AL CONTENEDOR BDOC
        if self._BDoc[uid].postsignWeb("BES", self.ruta_certificado, data['firma']):
            # AQUI HAY QUE BORRAR EL CERTIFICADO Y CREO QUE LOS ARCHIVOS
            pass
        
        # ACTUALIZAMOS EL NUEVO BDOC DEVUELTO POR LA LIBRERIA LIBDIGIDOC. ESTO ES UN SIMULACRO DEL ARCHIVO QUE NOS DEVUELVE LIBDIGIDOC CON EL NUEVO FIRMANTE
        self._BDoc[uid].saveBDocContainer(self.ruta_bdoc)
        archivo_bdoc = base64.encodestring(open(self.ruta_bdoc,"r").read())
        obj_documento = self.pool.get('firma.documento')
        data = obj_documento.read(cr,uid,[self.idDocumento])[0] # PARECE QUE EL PR
        data['documento'] = archivo_bdoc
        data['id_bandeja_actual'] = data['id_bandeja_actual'][0]
        obj_documento.write(cr,uid,[self.idDocumento],data,context=context)
        
        return obj_documento.listar_firmantes(cr,uid,[self.idDocumento],context)
        
        

firma_firmar()

class firma_info(osv.osv):
    
    _name = "firma.info"
    _rec_name = 'perfil'
    _columns = {
        'perfil': fields.selection([('BES','BES'),('TM','TM')],'Perfil de la Firma',required=True),
        'ciudad': fields.char('Ciudad',size=40,required=True),
        'estado': fields.char('Estado',size=40,required=True),
        'pais': fields.char('País',size=40,required=True),
        'codigo_postal': fields.char('Código Postal',size=10, required=True),
        'rol': fields.char('Rol Firmante',size=50, required=True),
        'usuario': fields.many2one('res.users','Usuario', required=False, ondelete='cascade'),
        'certificado': fields.text('Certificado',required=True),
        'id_certificado': fields.char('ID Certificado',size=40,required=True)
    }
    
    id_documento = None
    
    def desplegar_form(self,cr,uid,ids,context=None):
        
        # OBTENEMOS EL ID DEL DOCUMENTO A FIRMAR
        self.id_documento = ids[0]
        
        id_info = self.search(cr,uid,[('usuario','=',uid)])
        
        return { 
            'view_type': 'form',
            'view_mode':'form',
            'res_model': 'firma.info',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'res_id': id_info,
            'ref': 'firma_info'
        }
    
    
    def create(self,cr,uid,ids,context=None):
        
        ids['usuario'] = uid
        return super(osv.osv, self).create(cr,uid,ids,context=context)
        
    
    def preparar_firma(self,cr,uid,ids,context=None):
        
        obj_info = self.read(cr,uid,ids)[0]
        # OBTENEMOS EL DOCUMENTOS A FIRMAR DE LA TABLA DE DOCUMENTO
        obj_documento = self.pool.get('firma.documento')
        row = obj_documento.browse(cr,uid,[self.id_documento])[0]
        
        # ARMAMOS LAS VARIABLES QUE VA A UTILIZAR LA FIRMA DEL DOCUMENTO PARA QUE EL USUARIO PUEDA PROCEDER A FIRMARLO
        data = {'nombre_bdoc':row.nombre}
        data['archivo_bdoc'] = row.documento
        data['nombre_adjunto'] = row.nombre_file
        data['tipo'] = row.nombre_file.strip().split('.')[-1]
        data['id_certificado'] = obj_info['id_certificado']
        
        obj_firmar = self.pool.get('firma.firmar')
        ids = [obj_firmar.create(cr,uid,data,context)]
        data = obj_firmar.read(cr, uid, ids)[0]
        obj_firmar.idDocumento = row.id
        
        return obj_firmar.cargar_archivo(cr,uid,ids,context=context,obj_info=obj_info)
        
        
    
    _sql_constraints = [('name_uniq','unique(usuario)','Es un campo único')]
        
        
    
firma_info()

class firma_bandeja_usuario(osv.osv):
    
    _rec_name = "bandeja"
    _name = "firma.bandeja_usuario"
    
    _columns = {
     
        'id_bandeja':fields.many2one('firma.bandeja','Bandeja', required=True), 
        'id_usuario':fields.many2one('res.users','Usuario', required=True),
        'permiso_crear': fields.boolean("Crear"),
        #'permiso_leer': fields.boolean("Lectura"),
        'permiso_firmar': fields.boolean("Firmar"),
        #'permiso_mover_a': fields.boolean("Mover a bandeja"),
        #'permiso_mover_de': fields.boolean("Mover de bandeja"),
        'permiso_eliminar': fields.boolean("Eliminar"),
        'permiso_aprobar': fields.boolean("Aprobar"),
        'permiso_cambiar_bandeja': fields.boolean("Cambiar permiso"),
    }
    
    
    _defaults = {
    
        'permiso_crear':lambda *a:False,
        #'permiso_leer':lambda *a:False,
        'permiso_firmar':lambda *a:False,
        'permiso_cambiar_bandeja':lambda *a:False,
        'permiso_eliminar':lambda *a:False,
        'permiso_aprobar':lambda *a:False,
        #'permiso_mover_a':lambda *a:False,
        #'permiso_mover_de':lambda *a:False,
    }
    
    _sql_constraints = [('bandeja_usuario','unique(id_bandeja,id_usuario)','Son campos únicos')]
    
    
firma_bandeja_usuario()


class firma_documento_usuario(osv.osv):
    
    _rec_name = "bandeja"
    _name = "firma.documento_usuario"
    
    _columns = {
     
        'id_documento':fields.many2one('firma.documento','Documento', required=True), 
        'id_usuario':fields.many2one('res.users','Usuario', required=True),
        'estado':fields.selection([('f','Firmado'),('r','Rechazado'),('e','Entrada')],'Perfil de la Firma',required=True)
        
    }


firma_documento_usuario()